# coding: utf-8
lib = File.expand_path('../lib', __FILE__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)
require 'swift_generator/version'

Gem::Specification.new do |spec|# for "generating swift classes"
  spec.name          = "swift_generator"
  spec.version       = SwiftGenerator::VERSION
  spec.authors       = ["Chris Kornher"]
  spec.email         = ["ckornher@mac.com"]

  spec.summary       = "Generate swift classes with JSON serialization, hashValue, copy and isEqual."
  spec.description   = %{Provides an API and command line tool for generating "pure" Swift classes,
                         enums either through a ruby API or command-line tool and a JSON spec file.}
  spec.homepage      = ""
  spec.license       = "MIT"

  spec.required_ruby_version = '>= 2.0.0'

  spec.files         = `git ls-files -z`.split("\x0").reject { |f| f.match(%r{^(test|spec|features)/}) }
  spec.bindir        = "exe"
  spec.executables   = spec.files.grep(%r{^exe/}) { |f| File.basename(f) }
  spec.require_paths = ["lib"]

  # if spec.respond_to?(:metadata)
  #   spec.metadata['allowed_push_host'] = "http://rubygems:n6uqyRnAqzQP3M@rubygems-noneventsystems.rhcloud.com/"
  # end

  spec.add_development_dependency "bundler", "~> 1.9"
  spec.add_development_dependency "rake", "~> 10.0"

  spec.add_runtime_dependency "json", "~> 1.8"
  spec.add_runtime_dependency "commander", "~> 4.0"

end
